package struts.kenkyu04.action;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Enumeration;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * DispatchAction Ɠ̋@\ȒPɗpł悤ɂNXłB
 * <ol>
 * <li>
 * tH[ &lt;html:submit property="_edit_" value="ݒ"/&gt; ̂悤
 * A_[o[ň͂nametsubmit{^pӂ܂B
 * </li>
 * <li>Ⴆ name="_edit_" ȃ{^submitꍇ edit ƂÕ\bhs܂B</li>
 * <li>edit ƂÕ\bhꍇ mapping.findForward("edit") ɃtH[h܂B</li>
 * <li>A_[o[ň͂p[^ꍇ unspecified \bhs܂B</li>
 * </ol>
 * @author kawaz http://www.kawaz.jp/pukiwiki/?Java%20Tips#EasyDispatchAction
 */
public class EasyDispatchAction extends Action {
	private static final Class[] METHOD_TYPES = new Class[]{ActionMapping.class, ActionForm.class, HttpServletRequest.class, HttpServletResponse.class};
//	private static final String PARAM_DISPATCH_ONECE = EasyDispatchAction.class.getName() + ".DISPATCH_ONECE";

	/**
	 * \bho鐳K\B
	 * ftHgł "_(.*)_" łύXꍇ͂̕ϐI[o[Ch܂B  
	 */
	protected Pattern METHOD_NAME_PATTERN = Pattern.compile("_(.+)_");

	/**
	 * 1x̃NGXgŃ\bhU蕪ŝ1xǂB
	 * tH[hłēx\bhU蕪ꍇ́ÃANVł̕ϐfalseɃI[o[Ch܂B
	 */
	protected boolean isDispatchOncePerRequest = true;

	/**
	 * p[^Ďs郁\bh؂ւ܂B
	 * DispatchAction Iȋ@\gꍇ̓I[o[ChȂłB
	 */
	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		//ActionɗOɑBaseActionɂĊɈxtH[hĂꍇ͍ēx\bhU蕪sȂB
//		if(isDispatchOncePerRequest && request.getAttribute(PARAM_DISPATCH_ONECE) != null) {
//			return unspecified(mapping, form, request, response);
//		}
		//p[^烁\bhTB
		Enumeration names = request.getParameterNames();
		while(names.hasMoreElements()) {
			String name = (String) names.nextElement();
			Matcher m = METHOD_NAME_PATTERN.matcher(name);
			if(m.find()) {
				//xU蕪tO𗧂Ă
//				request.setAttribute(PARAM_DISPATCH_ONECE, Boolean.TRUE);
				//U蕪s
				String destination = m.group(1);
				Method method = getMethod(destination);
				if(method != null) {
					try {
					return (ActionForward) method.invoke(this, new Object[]{mapping, form, request, response});
					} catch (InvocationTargetException e){
						throw new ServletException(e.getTargetException());
					}
				} else {
					ActionForward forward = mapping.findForward(destination);
					if(forward != null)
						return forward;
					return unspecified(mapping, form, request, response);
				}
			}
		}
		//\bhw肪Ȃꍇ̃ftHg
		return unspecified(mapping, form, request, response);
	}

	/**
	 * execute\bhT܂B
	 * @param name
	 * @return
	 */
	protected Method getMethod(String name) {
		if(name == null || name.equals("execute")) {
			return null;
		}
		try {
			return getClass().getMethod(name, METHOD_TYPES);
		} catch (Exception e) {
			return null;
		}
	}

	/**
	 * \bhw肳ȂꍇɎsftHg̃\bhłB
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 */
	protected ActionForward unspecified(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) throws Exception{
		return null;
	}
}
