package struts.kenkyu04.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.ResultSetHandler;
import org.apache.commons.dbutils.handlers.BeanHandler;
import org.apache.commons.dbutils.handlers.BeanListHandler;

import struts.kenkyu04.dto.ProductRecord;

public class ProductDao {

	/**
	 * ȋSB
	 * @param conn	DBڑ
	 * @return	List<ProductRecord>
	 * @throws SQLException
	 */
	public static List select(Connection conn) throws SQLException{
		QueryRunner run = new QueryRunner();
		ResultSetHandler h = new BeanListHandler(ProductRecord.class);

		//ʂ̊eR[hABeanɊi[ȂSR[hListƂĎ擾
		List resultList = (List)run.query(
				conn, "select * from products", h);
		
		return resultList;
	}
	
	/**
	 * iPKB
	 * @param conn	DBڑ
	 * @param pcode	iR[h
	 * @return	w肵iR[h̏i
	 * @throws SQLException
	 */
	public static ProductRecord findByPK(Connection conn, int pcode) throws SQLException{
		QueryRunner run = new QueryRunner();
		ResultSetHandler h = new BeanHandler(ProductRecord.class);

		//ʂABeanƂĎ擾
		ProductRecord bean = (ProductRecord)run.query(
				conn, "select * from products where pcode = ?", 
				new Integer(pcode), h);
		
		return bean;
	}
	/**
	 * i̍폜
	 * @param conn	DBڑ
	 * @param pcode	폜鏤ȉiR[h
	 * @throws SQLException
	 */
	public static void deleteByPK(Connection conn, int pcode) throws SQLException{
		QueryRunner run = new QueryRunner();
		run.update(conn, "delete from products where pcode = ?", new Integer(pcode));
	}
	
	/**
	 * w肵i̍XVB
	 * @param conn	DBڑ
	 * @param pcode	XV鏤ȉiR[h
	 * @param newValue	XV̏i
	 * @throws SQLException
	 */
	public static void updateByPK(Connection conn, int pcode, ProductRecord newValue)
	 throws SQLException{
		QueryRunner run = new QueryRunner();
		run.update(conn, 
				"update products set " +
				"pcode = ?," +
				"pname = ?," +
				"price = ?," +
				"date_available = ? " +
				"where pcode = ?",
				new Object[]{
					newValue.getPcode(),
					newValue.getPname(),
					newValue.getPrice(),
					newValue.getDate_available(),
					new Integer(pcode),
				});
	}
	/**
	 * i̐VKo^
	 * @param conn	DBڑ
	 * @param newValue	쐬VR[h
	 * @throws SQLException
	 */
	public static void insert(Connection conn, ProductRecord newValue) throws SQLException{
		QueryRunner run = new QueryRunner();
		run.update(conn, 
				"insert into Products(pcode, pname, price, date_available)"
				+ " values("
				+ " (select max(pcode) + 1 from Products),"		//̍̔ԏ
				+ " ?,"
				+ " ?,"
				+ " ?)",
				new Object[]{
					newValue.getPname(),
					newValue.getPrice(),
					newValue.getDate_available(),
				});
		
	}
}
